/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "grammar.y"


#ifdef HAVE_CONFIG_H 
#include "config.h"
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>

#ifdef HAVE_STDINT_H
#include <stdint.h>
#endif

#include "util.h"
#include "output_util.h"
#include "rbtree.h"
#include "filter.h"
#include "nfdump.h"
#include "nffile.h"
#include "nftree.h"
#include "ipconv.h"

#define AnyMask 0xffffffffffffffffLL

/*
 * function prototypes
 */
static void  yyerror(char *msg);

static uint32_t ChainHosts(uint64_t *offsets, uint64_t *hostlist, int num_records, int type);

static uint64_t VerifyMac(char *s);

static int InitSymbols(void);

static uint32_t Get_fwd_status_id(char *status);

enum { DIR_UNSPEC = 1, 
	   SOURCE, DESTINATION, SOURCE_AND_DESTINATION, SOURCE_OR_DESTINATION, 
	   DIR_IN, DIR_OUT, 
	   IN_SRC, IN_DST, OUT_SRC, OUT_DST, 
	   ADJ_PREV, ADJ_NEXT };

enum { IS_START = 0, IS_END };

/* var defs */
extern int 			lineno;
extern char 		*yytext;
extern uint64_t		*IPstack;
extern uint32_t	StartNode;
extern uint16_t	Extended;
extern int (*FilterEngine)(uint32_t *);
extern char	*FilterFilename;

static uint32_t num_ip;

static struct fwd_status_def_s {
	uint32_t	id;
	char		*name;
} fwd_status_def_list[] = {
	{ 0,	"Ukwn"}, 	// Unknown
	{ 1,	"Forw"}, 	// Normal forwarding
	{ 2,	"Frag"}, 	// Fragmented
	{ 16,	"Drop"}, 	// Drop
	{ 17,	"DaclD"},	// Drop ACL deny
	{ 18,	"Daclp"},	// Drop ACL drop
	{ 19,	"Noroute"},	// Unroutable
	{ 20,	"Dadj"}, 	// Drop Adjacency
	{ 21,	"Dfrag"}, 	// Drop Fragmentation & DF set
	{ 22,	"Dbadh"}, 	// Drop Bad header checksum
	{ 23,	"Dbadtlen"}, // Drop Bad total Length
	{ 24,	"Dbadhlen"}, // Drop Bad Header Length
	{ 25,	"DbadTTL"}, // Drop bad TTL
	{ 26,	"Dpolicy"}, // Drop Policer
	{ 27,	"Dwred"}, 	// Drop WRED
	{ 28,	"Drpf"}, 	// Drop RPF
	{ 29,	"Dforus"}, 	// Drop For us
	{ 30,	"DbadOf"}, 	// Drop Bad output interface
	{ 31,	"Dhw"}, 	// Drop Hardware
	{ 128,	"Term"}, 	// Terminate
	{ 129,	"Tadj"}, 	// Terminate Punt Adjacency
	{ 130,	"TincAdj"}, // Terminate Incomplete Adjacency
	{ 131,	"Tforus"}, 	// Terminate For us
	{ 0,	NULL}		// Last entry
};

static char **fwd_status = NULL;

char yyerror_buff[256];

#define MPLSMAX 0x00ffffff

#line 170 "grammar.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_GRAMMAR_H_INCLUDED
# define YY_YY_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    ANY = 258,                     /* ANY  */
    IP = 259,                      /* IP  */
    IF = 260,                      /* IF  */
    MAC = 261,                     /* MAC  */
    MPLS = 262,                    /* MPLS  */
    TOS = 263,                     /* TOS  */
    DIR = 264,                     /* DIR  */
    FLAGS = 265,                   /* FLAGS  */
    PROTO = 266,                   /* PROTO  */
    MASK = 267,                    /* MASK  */
    NET = 268,                     /* NET  */
    PORT = 269,                    /* PORT  */
    FWDSTAT = 270,                 /* FWDSTAT  */
    IN = 271,                      /* IN  */
    OUT = 272,                     /* OUT  */
    SRC = 273,                     /* SRC  */
    DST = 274,                     /* DST  */
    EQ = 275,                      /* EQ  */
    LT = 276,                      /* LT  */
    GT = 277,                      /* GT  */
    LE = 278,                      /* LE  */
    GE = 279,                      /* GE  */
    PREV = 280,                    /* PREV  */
    NEXT = 281,                    /* NEXT  */
    IDENT = 282,                   /* IDENT  */
    ENGINE_TYPE = 283,             /* ENGINE_TYPE  */
    ENGINE_ID = 284,               /* ENGINE_ID  */
    AS = 285,                      /* AS  */
    PACKETS = 286,                 /* PACKETS  */
    BYTES = 287,                   /* BYTES  */
    FLOWS = 288,                   /* FLOWS  */
    NFVERSION = 289,               /* NFVERSION  */
    PPS = 290,                     /* PPS  */
    BPS = 291,                     /* BPS  */
    BPP = 292,                     /* BPP  */
    DURATION = 293,                /* DURATION  */
    NOT = 294,                     /* NOT  */
    IPV4 = 295,                    /* IPV4  */
    IPV6 = 296,                    /* IPV6  */
    BGPNEXTHOP = 297,              /* BGPNEXTHOP  */
    ROUTER = 298,                  /* ROUTER  */
    VLAN = 299,                    /* VLAN  */
    CLIENT = 300,                  /* CLIENT  */
    SERVER = 301,                  /* SERVER  */
    APP = 302,                     /* APP  */
    LATENCY = 303,                 /* LATENCY  */
    SYSID = 304,                   /* SYSID  */
    ASA = 305,                     /* ASA  */
    DENIED = 306,                  /* DENIED  */
    XEVENT = 307,                  /* XEVENT  */
    XNET = 308,                    /* XNET  */
    XPORT = 309,                   /* XPORT  */
    INGRESS = 310,                 /* INGRESS  */
    EGRESS = 311,                  /* EGRESS  */
    ACL = 312,                     /* ACL  */
    ACE = 313,                     /* ACE  */
    XACE = 314,                    /* XACE  */
    NAT = 315,                     /* NAT  */
    ADD = 316,                     /* ADD  */
    EVENT = 317,                   /* EVENT  */
    VRF = 318,                     /* VRF  */
    NPORT = 319,                   /* NPORT  */
    NIP = 320,                     /* NIP  */
    PBLOCK = 321,                  /* PBLOCK  */
    START = 322,                   /* START  */
    END = 323,                     /* END  */
    STEP = 324,                    /* STEP  */
    SIZE = 325,                    /* SIZE  */
    STRING = 326,                  /* STRING  */
    REASON = 327,                  /* REASON  */
    NUMBER = 328,                  /* NUMBER  */
    PORTNUM = 329,                 /* PORTNUM  */
    ICMP_TYPE = 330,               /* ICMP_TYPE  */
    ICMP_CODE = 331,               /* ICMP_CODE  */
    OR = 332,                      /* OR  */
    AND = 333,                     /* AND  */
    NEGATE = 334                   /* NEGATE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define ANY 258
#define IP 259
#define IF 260
#define MAC 261
#define MPLS 262
#define TOS 263
#define DIR 264
#define FLAGS 265
#define PROTO 266
#define MASK 267
#define NET 268
#define PORT 269
#define FWDSTAT 270
#define IN 271
#define OUT 272
#define SRC 273
#define DST 274
#define EQ 275
#define LT 276
#define GT 277
#define LE 278
#define GE 279
#define PREV 280
#define NEXT 281
#define IDENT 282
#define ENGINE_TYPE 283
#define ENGINE_ID 284
#define AS 285
#define PACKETS 286
#define BYTES 287
#define FLOWS 288
#define NFVERSION 289
#define PPS 290
#define BPS 291
#define BPP 292
#define DURATION 293
#define NOT 294
#define IPV4 295
#define IPV6 296
#define BGPNEXTHOP 297
#define ROUTER 298
#define VLAN 299
#define CLIENT 300
#define SERVER 301
#define APP 302
#define LATENCY 303
#define SYSID 304
#define ASA 305
#define DENIED 306
#define XEVENT 307
#define XNET 308
#define XPORT 309
#define INGRESS 310
#define EGRESS 311
#define ACL 312
#define ACE 313
#define XACE 314
#define NAT 315
#define ADD 316
#define EVENT 317
#define VRF 318
#define NPORT 319
#define NIP 320
#define PBLOCK 321
#define START 322
#define END 323
#define STEP 324
#define SIZE 325
#define STRING 326
#define REASON 327
#define NUMBER 328
#define PORTNUM 329
#define ICMP_TYPE 330
#define ICMP_CODE 331
#define OR 332
#define AND 333
#define NEGATE 334

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 131 "grammar.y"

	uint64_t		value;
	char			*s;
	FilterParam_t	param;
	void			*list;

#line 388 "grammar.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAMMAR_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ANY = 3,                        /* ANY  */
  YYSYMBOL_IP = 4,                         /* IP  */
  YYSYMBOL_IF = 5,                         /* IF  */
  YYSYMBOL_MAC = 6,                        /* MAC  */
  YYSYMBOL_MPLS = 7,                       /* MPLS  */
  YYSYMBOL_TOS = 8,                        /* TOS  */
  YYSYMBOL_DIR = 9,                        /* DIR  */
  YYSYMBOL_FLAGS = 10,                     /* FLAGS  */
  YYSYMBOL_PROTO = 11,                     /* PROTO  */
  YYSYMBOL_MASK = 12,                      /* MASK  */
  YYSYMBOL_NET = 13,                       /* NET  */
  YYSYMBOL_PORT = 14,                      /* PORT  */
  YYSYMBOL_FWDSTAT = 15,                   /* FWDSTAT  */
  YYSYMBOL_IN = 16,                        /* IN  */
  YYSYMBOL_OUT = 17,                       /* OUT  */
  YYSYMBOL_SRC = 18,                       /* SRC  */
  YYSYMBOL_DST = 19,                       /* DST  */
  YYSYMBOL_EQ = 20,                        /* EQ  */
  YYSYMBOL_LT = 21,                        /* LT  */
  YYSYMBOL_GT = 22,                        /* GT  */
  YYSYMBOL_LE = 23,                        /* LE  */
  YYSYMBOL_GE = 24,                        /* GE  */
  YYSYMBOL_PREV = 25,                      /* PREV  */
  YYSYMBOL_NEXT = 26,                      /* NEXT  */
  YYSYMBOL_IDENT = 27,                     /* IDENT  */
  YYSYMBOL_ENGINE_TYPE = 28,               /* ENGINE_TYPE  */
  YYSYMBOL_ENGINE_ID = 29,                 /* ENGINE_ID  */
  YYSYMBOL_AS = 30,                        /* AS  */
  YYSYMBOL_PACKETS = 31,                   /* PACKETS  */
  YYSYMBOL_BYTES = 32,                     /* BYTES  */
  YYSYMBOL_FLOWS = 33,                     /* FLOWS  */
  YYSYMBOL_NFVERSION = 34,                 /* NFVERSION  */
  YYSYMBOL_PPS = 35,                       /* PPS  */
  YYSYMBOL_BPS = 36,                       /* BPS  */
  YYSYMBOL_BPP = 37,                       /* BPP  */
  YYSYMBOL_DURATION = 38,                  /* DURATION  */
  YYSYMBOL_NOT = 39,                       /* NOT  */
  YYSYMBOL_IPV4 = 40,                      /* IPV4  */
  YYSYMBOL_IPV6 = 41,                      /* IPV6  */
  YYSYMBOL_BGPNEXTHOP = 42,                /* BGPNEXTHOP  */
  YYSYMBOL_ROUTER = 43,                    /* ROUTER  */
  YYSYMBOL_VLAN = 44,                      /* VLAN  */
  YYSYMBOL_CLIENT = 45,                    /* CLIENT  */
  YYSYMBOL_SERVER = 46,                    /* SERVER  */
  YYSYMBOL_APP = 47,                       /* APP  */
  YYSYMBOL_LATENCY = 48,                   /* LATENCY  */
  YYSYMBOL_SYSID = 49,                     /* SYSID  */
  YYSYMBOL_ASA = 50,                       /* ASA  */
  YYSYMBOL_DENIED = 51,                    /* DENIED  */
  YYSYMBOL_XEVENT = 52,                    /* XEVENT  */
  YYSYMBOL_XNET = 53,                      /* XNET  */
  YYSYMBOL_XPORT = 54,                     /* XPORT  */
  YYSYMBOL_INGRESS = 55,                   /* INGRESS  */
  YYSYMBOL_EGRESS = 56,                    /* EGRESS  */
  YYSYMBOL_ACL = 57,                       /* ACL  */
  YYSYMBOL_ACE = 58,                       /* ACE  */
  YYSYMBOL_XACE = 59,                      /* XACE  */
  YYSYMBOL_NAT = 60,                       /* NAT  */
  YYSYMBOL_ADD = 61,                       /* ADD  */
  YYSYMBOL_EVENT = 62,                     /* EVENT  */
  YYSYMBOL_VRF = 63,                       /* VRF  */
  YYSYMBOL_NPORT = 64,                     /* NPORT  */
  YYSYMBOL_NIP = 65,                       /* NIP  */
  YYSYMBOL_PBLOCK = 66,                    /* PBLOCK  */
  YYSYMBOL_START = 67,                     /* START  */
  YYSYMBOL_END = 68,                       /* END  */
  YYSYMBOL_STEP = 69,                      /* STEP  */
  YYSYMBOL_SIZE = 70,                      /* SIZE  */
  YYSYMBOL_STRING = 71,                    /* STRING  */
  YYSYMBOL_REASON = 72,                    /* REASON  */
  YYSYMBOL_NUMBER = 73,                    /* NUMBER  */
  YYSYMBOL_PORTNUM = 74,                   /* PORTNUM  */
  YYSYMBOL_ICMP_TYPE = 75,                 /* ICMP_TYPE  */
  YYSYMBOL_ICMP_CODE = 76,                 /* ICMP_CODE  */
  YYSYMBOL_77_ = 77,                       /* '+'  */
  YYSYMBOL_OR = 78,                        /* OR  */
  YYSYMBOL_79_ = 79,                       /* '*'  */
  YYSYMBOL_AND = 80,                       /* AND  */
  YYSYMBOL_NEGATE = 81,                    /* NEGATE  */
  YYSYMBOL_82_ = 82,                       /* '['  */
  YYSYMBOL_83_ = 83,                       /* ']'  */
  YYSYMBOL_84_ = 84,                       /* '/'  */
  YYSYMBOL_85_ = 85,                       /* ','  */
  YYSYMBOL_86_ = 86,                       /* '('  */
  YYSYMBOL_87_ = 87,                       /* ')'  */
  YYSYMBOL_88_ = 88,                       /* '%'  */
  YYSYMBOL_YYACCEPT = 89,                  /* $accept  */
  YYSYMBOL_prog = 90,                      /* prog  */
  YYSYMBOL_term = 91,                      /* term  */
  YYSYMBOL_iplist = 92,                    /* iplist  */
  YYSYMBOL_ullist = 93,                    /* ullist  */
  YYSYMBOL_comp = 94,                      /* comp  */
  YYSYMBOL_dqual = 95,                     /* dqual  */
  YYSYMBOL_inout = 96,                     /* inout  */
  YYSYMBOL_acl = 97,                       /* acl  */
  YYSYMBOL_expr = 98                       /* expr  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  101
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   311

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  89
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  112
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  241

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   334


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    88,     2,     2,
      86,    87,    79,    77,    85,     2,     2,    84,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    82,     2,    83,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    78,    80,    81
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   157,   157,   158,   163,   167,   177,   182,   187,   203,
     218,   236,   253,   257,   261,   265,   269,   273,   305,   317,
     326,   337,   367,   413,   441,   468,   474,   501,   528,   532,
     536,   540,   548,   581,   608,   672,   688,   704,   713,   722,
     746,   759,   779,   803,   817,   907,   945,   985,  1003,  1016,
    1029,  1042,  1055,  1068,  1081,  1094,  1132,  1183,  1215,  1254,
    1318,  1351,  1441,  1526,  1552,  1585,  1647,  1802,  1816,  1824,
    1835,  1844,  1860,  1903,  1957,  1988,  2020,  2064,  2085,  2096,
    2110,  2111,  2112,  2113,  2114,  2115,  2119,  2120,  2121,  2122,
    2123,  2124,  2125,  2126,  2127,  2128,  2129,  2130,  2131,  2132,
    2133,  2136,  2137,  2140,  2141,  2142,  2145,  2146,  2147,  2148,
    2149,  2150,  2159
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ANY", "IP", "IF",
  "MAC", "MPLS", "TOS", "DIR", "FLAGS", "PROTO", "MASK", "NET", "PORT",
  "FWDSTAT", "IN", "OUT", "SRC", "DST", "EQ", "LT", "GT", "LE", "GE",
  "PREV", "NEXT", "IDENT", "ENGINE_TYPE", "ENGINE_ID", "AS", "PACKETS",
  "BYTES", "FLOWS", "NFVERSION", "PPS", "BPS", "BPP", "DURATION", "NOT",
  "IPV4", "IPV6", "BGPNEXTHOP", "ROUTER", "VLAN", "CLIENT", "SERVER",
  "APP", "LATENCY", "SYSID", "ASA", "DENIED", "XEVENT", "XNET", "XPORT",
  "INGRESS", "EGRESS", "ACL", "ACE", "XACE", "NAT", "ADD", "EVENT", "VRF",
  "NPORT", "NIP", "PBLOCK", "START", "END", "STEP", "SIZE", "STRING",
  "REASON", "NUMBER", "PORTNUM", "ICMP_TYPE", "ICMP_CODE", "'+'", "OR",
  "'*'", "AND", "NEGATE", "'['", "']'", "'/'", "','", "'('", "')'", "'%'",
  "$accept", "prog", "term", "iplist", "ullist", "comp", "dqual", "inout",
  "acl", "expr", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,    43,   332,    42,
     333,   334,    91,    93,    47,    44,    40,    41,    37
};
#endif

#define YYPACT_NINF (-165)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-3)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     113,  -165,    15,   -42,    21,   -19,   -16,     6,   107,   -20,
      26,  -165,    60,    -2,   160,   160,   160,   160,   160,   160,
     160,   160,   187,  -165,  -165,   106,   111,    69,    71,    73,
      54,     1,    81,    82,    95,    66,    88,    91,   187,    94,
     166,  -165,   246,    32,    34,    98,   160,  -165,  -165,  -165,
    -165,  -165,  -165,  -165,  -165,  -165,  -165,  -165,    99,  -165,
    -165,  -165,  -165,  -165,  -165,  -165,  -165,   148,   167,   169,
     173,    -6,  -165,   112,   119,   120,   122,   127,   134,   135,
     136,  -165,   139,   140,   160,   160,   160,  -165,   160,    -1,
     160,   160,    16,   160,   160,   160,   160,  -165,  -165,     7,
     131,  -165,    -5,   145,   164,   160,   146,   168,   154,   245,
     160,   160,   158,   170,   160,   160,    -4,  -165,  -165,  -165,
     160,   187,   187,  -165,   165,  -165,  -165,  -165,  -165,  -165,
     162,  -165,  -165,  -165,  -165,  -165,  -165,  -165,  -165,  -165,
    -165,  -165,   172,   175,   176,   182,   -23,  -165,   183,   184,
     191,  -165,   197,   198,   199,   201,   206,   152,   187,   200,
    -165,  -165,  -165,   207,  -165,    -9,   -36,   208,   202,   210,
     212,   213,  -165,   203,   215,   216,   209,  -165,   219,   214,
    -165,  -165,   222,  -165,  -165,  -165,  -165,  -165,  -165,  -165,
    -165,  -165,  -165,  -165,  -165,  -165,  -165,   224,    31,   222,
    -165,  -165,   223,  -165,   225,  -165,   225,  -165,  -165,  -165,
     228,  -165,  -165,   222,  -165,   218,   -56,  -165,  -165,   -24,
    -165,  -165,   -57,    22,  -165,   -15,   230,   220,  -165,   226,
    -165,  -165,  -165,   232,  -165,  -165,  -165,   233,  -165,  -165,
    -165
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
      86,     4,     0,     0,    80,     0,     0,    93,    94,    87,
      88,    99,   100,     0,    80,    80,    80,    80,    80,    80,
      80,    80,    86,     6,     7,     0,     0,     0,     0,     0,
       0,     0,   101,   102,     0,     0,     0,     0,    86,     0,
       0,   106,     0,     0,     3,     0,    80,   101,   102,    70,
      71,    81,    82,    83,    84,    85,    20,    21,     0,     9,
       8,    69,    68,    95,    96,    97,    98,     0,     0,     0,
       0,     0,     5,     0,     0,     0,     0,     0,     0,     0,
       0,   109,     0,     0,    80,    80,    80,    31,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    35,    36,     0,
       0,     1,     0,     0,     0,    80,     0,     0,    80,    80,
      80,    80,     0,     0,    80,    80,     0,   103,   104,   105,
      80,    86,    86,    67,     0,    18,    89,    91,    90,    92,
       0,    24,    37,    38,    12,    19,    13,    14,    15,    16,
      26,    27,     0,     0,     0,     0,     0,    39,     0,     0,
       0,    47,     0,     0,     0,     0,     0,   110,    86,     0,
      22,    63,    65,     0,    60,     0,     0,     0,     0,     0,
       0,     0,    64,     0,     0,     0,     0,    56,     0,   107,
     108,    66,     0,    28,    29,    30,    43,    42,    41,    40,
      49,    50,    48,    51,    52,    53,    54,     0,     0,     0,
      17,    61,     0,    33,     0,    32,     0,    58,    10,    11,
       0,    45,    55,     0,    46,    72,     0,   111,   112,     0,
      62,    77,     0,     0,    44,     0,     0,    74,    25,     0,
      23,    78,    34,     0,    59,    57,    73,     0,    75,    79,
      76
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -165,  -165,  -165,  -164,    40,   -12,  -165,    -3,  -165,   -21
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    40,    41,   216,   222,    58,    42,    43,   120,    44
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      50,    81,    73,    74,    75,    76,    77,    78,    79,    80,
     130,   159,   176,    47,    48,   227,   231,    99,    45,    51,
      52,    53,    54,    55,    63,    64,   232,   228,   233,   229,
     203,    49,    47,    48,   124,   219,    51,    52,    53,    54,
      55,    51,    52,    53,    54,    55,   204,   227,   187,   225,
     146,    56,    59,    88,    60,    61,   227,    62,    67,   230,
      68,   229,   201,    89,    71,   131,   160,   177,   235,    72,
     229,   147,   142,   143,   144,   202,   145,   148,   149,   150,
     152,   153,   154,   155,   156,   121,    46,   122,   151,   117,
     118,   119,    57,   163,   157,   231,   167,   169,   170,   171,
     179,   180,   174,   175,    69,   234,    70,   233,   178,   121,
      82,   122,   121,    -2,   122,    83,     1,    84,   218,    85,
       2,    86,     3,     4,     5,    65,    66,    87,     6,     7,
       8,     9,    10,    93,    94,    95,    96,   198,    11,    12,
      13,    14,    15,   188,    90,    91,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    92,    27,    28,
      29,    97,    30,    31,    98,   100,   101,   126,    32,    33,
     166,   123,   125,    34,    51,    52,    53,    54,    55,    35,
      51,    52,    53,    54,    55,   132,   127,   128,    36,    37,
       1,   129,   133,   134,     2,   135,     3,     4,     5,    38,
     136,    39,     6,     7,     8,     9,    10,   137,   138,   139,
     140,   141,    11,    12,    13,    14,    15,   158,   161,   164,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,   172,    27,    28,    29,   162,    30,    31,   181,   165,
     197,   173,    32,    33,   182,   183,   223,    34,   184,   185,
     102,   103,   104,    35,   105,   186,   189,   190,   106,   107,
     108,   168,    36,    37,   191,    51,    52,    53,    54,    55,
     192,   193,   194,    38,   195,    39,   109,   110,   111,   196,
     200,   205,   199,   207,   206,   208,   209,   210,   211,   212,
     112,   213,   214,   215,   122,   217,   220,   238,   221,   113,
     114,   224,   226,   236,   237,   239,   240,     0,     0,     0,
     115,   116
};

static const yytype_int16 yycheck[] =
{
       3,    22,    14,    15,    16,    17,    18,    19,    20,    21,
      16,    16,    16,    55,    56,    71,    73,    38,     3,    20,
      21,    22,    23,    24,    18,    19,    83,    83,    85,    85,
      66,    73,    55,    56,    46,   199,    20,    21,    22,    23,
      24,    20,    21,    22,    23,    24,    82,    71,    71,   213,
      51,    30,    71,    52,    73,    71,    71,    73,    78,    83,
      80,    85,    71,    62,     4,    71,    71,    71,    83,    71,
      85,    72,    84,    85,    86,    84,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    78,    71,    80,    72,    57,
      58,    59,    71,   105,    87,    73,   108,   109,   110,   111,
     121,   122,   114,   115,    78,    83,    80,    85,   120,    78,
       4,    80,    78,     0,    80,     4,     3,    48,    87,    48,
       7,    48,     9,    10,    11,    18,    19,    73,    15,    16,
      17,    18,    19,    67,    68,    69,    70,   158,    25,    26,
      27,    28,    29,   146,    63,    63,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    62,    45,    46,
      47,    73,    49,    50,    73,    71,     0,    19,    55,    56,
      16,    73,    73,    60,    20,    21,    22,    23,    24,    66,
      20,    21,    22,    23,    24,    73,    19,    18,    75,    76,
       3,    18,    73,    73,     7,    73,     9,    10,    11,    86,
      73,    88,    15,    16,    17,    18,    19,    73,    73,    73,
      71,    71,    25,    26,    27,    28,    29,    86,    73,    73,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    73,    45,    46,    47,    71,    49,    50,    73,    71,
      88,    71,    55,    56,    82,    73,   206,    60,    73,    73,
       4,     5,     6,    66,     8,    73,    73,    73,    12,    13,
      14,    16,    75,    76,    73,    20,    21,    22,    23,    24,
      73,    73,    73,    86,    73,    88,    30,    31,    32,    73,
      73,    73,    82,    73,    82,    73,    73,    84,    73,    73,
      44,    82,    73,    71,    80,    71,    73,    71,    73,    53,
      54,    73,    84,    73,    84,    73,    73,    -1,    -1,    -1,
      64,    65
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     7,     9,    10,    11,    15,    16,    17,    18,
      19,    25,    26,    27,    28,    29,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    45,    46,    47,
      49,    50,    55,    56,    60,    66,    75,    76,    86,    88,
      90,    91,    95,    96,    98,     3,    71,    55,    56,    73,
      96,    20,    21,    22,    23,    24,    30,    71,    94,    71,
      73,    71,    73,    18,    19,    18,    19,    78,    80,    78,
      80,     4,    71,    94,    94,    94,    94,    94,    94,    94,
      94,    98,     4,     4,    48,    48,    48,    73,    52,    62,
      63,    63,    62,    67,    68,    69,    70,    73,    73,    98,
      71,     0,     4,     5,     6,     8,    12,    13,    14,    30,
      31,    32,    44,    53,    54,    64,    65,    57,    58,    59,
      97,    78,    80,    73,    94,    73,    19,    19,    18,    18,
      16,    71,    73,    73,    73,    73,    73,    73,    73,    73,
      71,    71,    94,    94,    94,    94,    51,    72,    94,    94,
      94,    72,    94,    94,    94,    94,    94,    87,    86,    16,
      71,    73,    71,    94,    73,    71,    16,    94,    16,    94,
      94,    94,    73,    71,    94,    94,    16,    71,    94,    98,
      98,    73,    82,    73,    73,    73,    73,    71,    96,    73,
      73,    73,    73,    73,    73,    73,    73,    88,    98,    82,
      73,    71,    84,    66,    82,    73,    82,    73,    73,    73,
      84,    73,    73,    82,    73,    71,    92,    71,    87,    92,
      73,    73,    93,    93,    73,    92,    84,    71,    83,    85,
      83,    73,    83,    85,    83,    83,    73,    84,    71,    73,
      73
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    89,    90,    90,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    91,    91,    91,    91,    91,    91,    91,    91,
      91,    91,    92,    92,    92,    92,    92,    93,    93,    93,
      94,    94,    94,    94,    94,    94,    95,    95,    95,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    95,
      95,    96,    96,    97,    97,    97,    98,    98,    98,    98,
      98,    98,    98
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     2,     2,
       4,     4,     3,     3,     3,     3,     3,     4,     3,     3,
       2,     2,     3,     6,     3,     6,     3,     3,     4,     4,
       4,     2,     4,     4,     6,     2,     2,     3,     3,     3,
       4,     4,     4,     4,     5,     4,     4,     3,     4,     4,
       4,     4,     4,     4,     4,     4,     3,     6,     4,     6,
       3,     4,     5,     3,     3,     3,     4,     3,     2,     2,
       2,     2,     1,     3,     2,     3,     4,     1,     2,     3,
       0,     1,     1,     1,     1,     1,     0,     1,     1,     3,
       3,     3,     3,     1,     1,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     2,
       3,     5,     5
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* prog: expr  */
#line 158 "grammar.y"
                {   
		StartNode = (yyvsp[0].value); 
	}
#line 1652 "grammar.c"
    break;

  case 4: /* term: ANY  */
#line 163 "grammar.y"
            { /* this is an unconditionally true expression, as a filter applies in any case */
		(yyval.param).self = NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL ); 
	}
#line 1660 "grammar.c"
    break;

  case 5: /* term: IDENT STRING  */
#line 167 "grammar.y"
                       {	
		if ( !ScreenIdentString((yyvsp[0].s)) ) {
			yyerror("Illegal ident string");
			YYABORT;
		}

		uint32_t	index = AddIdent((yyvsp[0].s));
		(yyval.param).self = NewBlock(0, 0, index, CMP_IDENT, FUNC_NONE, NULL ); 
	}
#line 1674 "grammar.c"
    break;

  case 6: /* term: IPV4  */
#line 177 "grammar.y"
               { 
		(yyval.param).self = NewBlock(OffsetRecordFlags, (1LL << ShiftRecordFlags)  & MaskRecordFlags, 
					(0LL << ShiftRecordFlags)  & MaskRecordFlags, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 1683 "grammar.c"
    break;

  case 7: /* term: IPV6  */
#line 182 "grammar.y"
               { 
		(yyval.param).self = NewBlock(OffsetRecordFlags, (1LL << ShiftRecordFlags)  & MaskRecordFlags, 
					(1LL << ShiftRecordFlags)  & MaskRecordFlags, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 1692 "grammar.c"
    break;

  case 8: /* term: PROTO NUMBER  */
#line 187 "grammar.y"
                       { 
		int64_t	proto;
		proto = (yyvsp[0].value);

		if ( proto > 255 ) {
			yyerror("Protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown protocol");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetProto, MaskProto, (proto << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL); 

	}
#line 1712 "grammar.c"
    break;

  case 9: /* term: PROTO STRING  */
#line 203 "grammar.y"
                       { 
		int64_t	proto;
		proto = ProtoNum((yyvsp[0].s));

		if ( proto > 255 ) {
			yyerror("Protocol number > 255");
			YYABORT;
		}
		if ( proto < 0 ) {
			yyerror("Unknown protocol");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetProto, MaskProto, (proto << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 1731 "grammar.c"
    break;

  case 10: /* term: dqual PACKETS comp NUMBER  */
#line 218 "grammar.y"
                                    { 

		switch ( (yyvsp[-3].param).direction ) {
			case DIR_UNSPEC:
			case DIR_IN: 
				(yyval.param).self = NewBlock(OffsetPackets, MaskPackets, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				(yyval.param).self = NewBlock(OffsetOutPackets, MaskPackets, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			default:
				/* should never happen */
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 1753 "grammar.c"
    break;

  case 11: /* term: dqual BYTES comp NUMBER  */
#line 236 "grammar.y"
                                  {	

		switch ( (yyvsp[-3].param).direction ) {
			case DIR_UNSPEC:
			case DIR_IN: 
				(yyval.param).self = NewBlock(OffsetBytes, MaskBytes, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				(yyval.param).self = NewBlock(OffsetOutBytes, MaskBytes, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 1774 "grammar.c"
    break;

  case 12: /* term: FLOWS comp NUMBER  */
#line 253 "grammar.y"
                            {	
			(yyval.param).self = NewBlock(OffsetAggrFlows, MaskFlows, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 1782 "grammar.c"
    break;

  case 13: /* term: PPS comp NUMBER  */
#line 257 "grammar.y"
                          {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_PPS, NULL); 
	}
#line 1790 "grammar.c"
    break;

  case 14: /* term: BPS comp NUMBER  */
#line 261 "grammar.y"
                          {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_BPS, NULL); 
	}
#line 1798 "grammar.c"
    break;

  case 15: /* term: BPP comp NUMBER  */
#line 265 "grammar.y"
                          {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_BPP, NULL); 
	}
#line 1806 "grammar.c"
    break;

  case 16: /* term: DURATION comp NUMBER  */
#line 269 "grammar.y"
                               {	
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_DURATION, NULL); 
	}
#line 1814 "grammar.c"
    break;

  case 17: /* term: dqual TOS comp NUMBER  */
#line 273 "grammar.y"
                                {	
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("TOS must be 0..255");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case DIR_UNSPEC:
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetTos, MaskTos, ((yyvsp[0].value) << ShiftTos) & MaskTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetDstTos, MaskDstTos, ((yyvsp[0].value) << ShiftDstTos) & MaskDstTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
				break;
			case SOURCE_OR_DESTINATION: 
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetTos, MaskTos, ((yyvsp[0].value) << ShiftTos) & MaskTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL),
					NewBlock(OffsetDstTos, MaskDstTos, ((yyvsp[0].value) << ShiftDstTos) & MaskDstTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetTos, MaskTos, ((yyvsp[0].value) << ShiftTos) & MaskTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL),
					NewBlock(OffsetDstTos, MaskDstTos, ((yyvsp[0].value) << ShiftDstTos) & MaskDstTos, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
			}
	}
#line 1850 "grammar.c"
    break;

  case 18: /* term: FLAGS comp NUMBER  */
#line 305 "grammar.y"
                                {	
		if ( (yyvsp[0].value) > 63 ) {
			yyerror("Flags must be 0..63");
			YYABORT;
		}
		(yyval.param).self = Connect_AND(
			// imply flags with a proto TCP block
			NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_TCP << ShiftProto) & MaskProto, CMP_EQ, FUNC_NONE, NULL),
			NewBlock(OffsetFlags, MaskFlags, ((yyvsp[0].value) << ShiftFlags) & MaskFlags, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
		);
	}
#line 1866 "grammar.c"
    break;

  case 19: /* term: NFVERSION comp NUMBER  */
#line 317 "grammar.y"
                                {	
		if ( (yyvsp[0].value) > 10 ) {
			yyerror("Netflow version must be <= 10");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetRecordVersion, MaskRecordVersion, ((yyvsp[0].value) << ShiftRecordVersion) & MaskRecordVersion, (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 1878 "grammar.c"
    break;

  case 20: /* term: FLAGS AS  */
#line 326 "grammar.y"
                        {	
		uint64_t fl = 0;
		fl |= 16;
		fl |= 2;
		(yyval.param).self = Connect_AND(
			// imply flags with a proto TCP block
			NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_TCP << ShiftProto) & MaskProto, CMP_EQ, FUNC_NONE, NULL),
			NewBlock(OffsetFlags, (fl << ShiftFlags) & MaskFlags, (fl << ShiftFlags) & MaskFlags, CMP_FLAGS, FUNC_NONE, NULL)
		);
	}
#line 1893 "grammar.c"
    break;

  case 21: /* term: FLAGS STRING  */
#line 337 "grammar.y"
                        {	
		uint64_t fl = 0;
		int cnt     = 0;
		size_t		len = strlen((yyvsp[0].s));

		if ( len > 7 ) {
			yyerror("Too many flags");
			YYABORT;
		}

		if ( strchr((yyvsp[0].s), 'F') ) { fl |=  1; cnt++; }
		if ( strchr((yyvsp[0].s), 'S') ) { fl |=  2; cnt++; }
		if ( strchr((yyvsp[0].s), 'R') ) { fl |=  4; cnt++; }
		if ( strchr((yyvsp[0].s), 'P') ) { fl |=  8; cnt++; }
		if ( strchr((yyvsp[0].s), 'A') ) { fl |=  16; cnt++; }
		if ( strchr((yyvsp[0].s), 'U') ) { fl |=  32; cnt++; }
		if ( strchr((yyvsp[0].s), 'X') ) { fl =  63; cnt++; }

		if ( cnt != len ) {
			yyerror("Too many flags");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			// imply flags with a proto TCP block
			NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_TCP << ShiftProto) & MaskProto, CMP_EQ, FUNC_NONE, NULL),
			NewBlock(OffsetFlags, (fl << ShiftFlags) & MaskFlags, (fl << ShiftFlags) & MaskFlags, CMP_FLAGS, FUNC_NONE, NULL)
		);
	}
#line 1927 "grammar.c"
    break;

  case 22: /* term: dqual IP STRING  */
#line 367 "grammar.y"
                          { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		if ( ret == -2 ) {
			// could not resolv host => 'not any'
			(yyval.param).self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetSrcIPv6a, OffsetSrcIPv6b, OffsetDstIPv6a, OffsetDstIPv6b };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( (yyvsp[-2].param).direction ) {
				case SOURCE:
				case DESTINATION:
					(yyval.param).self = ChainHosts(offsets, IPstack, num_ip, (yyvsp[-2].param).direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} // End of switch

		}
	}
#line 1977 "grammar.c"
    break;

  case 23: /* term: dqual IP IN '[' iplist ']'  */
#line 413 "grammar.y"
                                     { 	

		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetSrcIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetDstIPv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}
	}
#line 2009 "grammar.c"
    break;

  case 24: /* term: NEXT IP STRING  */
#line 441 "grammar.y"
                         { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			NewBlock(OffsetNexthopv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetNexthopv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2040 "grammar.c"
    break;

  case 25: /* term: NEXT IP IN '[' iplist ']'  */
#line 468 "grammar.y"
                                    { 	

		(yyval.param).self = NewBlock(OffsetNexthopv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );

	}
#line 2050 "grammar.c"
    break;

  case 26: /* term: BGPNEXTHOP IP STRING  */
#line 474 "grammar.y"
                               { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			NewBlock(OffsetBGPNexthopv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetBGPNexthopv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2081 "grammar.c"
    break;

  case 27: /* term: ROUTER IP STRING  */
#line 501 "grammar.y"
                           { 	
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		(yyval.param).self = Connect_AND(
			NewBlock(OffsetRouterv6b, MaskIPv6, IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetRouterv6a, MaskIPv6, IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
		);
	}
#line 2112 "grammar.c"
    break;

  case 28: /* term: CLIENT LATENCY comp NUMBER  */
#line 528 "grammar.y"
                                     { 	
		(yyval.param).self = NewBlock(OffsetClientLatency, MaskLatency, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 2120 "grammar.c"
    break;

  case 29: /* term: SERVER LATENCY comp NUMBER  */
#line 532 "grammar.y"
                                     { 	
		(yyval.param).self = NewBlock(OffsetServerLatency, MaskLatency, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 2128 "grammar.c"
    break;

  case 30: /* term: APP LATENCY comp NUMBER  */
#line 536 "grammar.y"
                                  { 	
		(yyval.param).self = NewBlock(OffsetAppLatency, MaskLatency, (yyvsp[0].value), (yyvsp[-1].param).comp, FUNC_NONE, NULL); 
	}
#line 2136 "grammar.c"
    break;

  case 31: /* term: SYSID NUMBER  */
#line 540 "grammar.y"
                       { 	
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Router SysID expected between be 1..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetExporterSysID, MaskExporterSysID, ((yyvsp[0].value) << ShiftExporterSysID) & MaskExporterSysID, CMP_EQ, FUNC_NONE, NULL); 
	}
#line 2148 "grammar.c"
    break;

  case 32: /* term: dqual PORT comp NUMBER  */
#line 548 "grammar.y"
                                 {	
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetPort, MaskSrcPort, ((yyvsp[0].value) << ShiftSrcPort) & MaskSrcPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetPort, MaskDstPort, ((yyvsp[0].value) << ShiftDstPort) & MaskDstPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, ((yyvsp[0].value) << ShiftSrcPort) & MaskSrcPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetPort, MaskDstPort, ((yyvsp[0].value) << ShiftDstPort) & MaskDstPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetPort, MaskSrcPort, ((yyvsp[0].value) << ShiftSrcPort) & MaskSrcPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetPort, MaskDstPort, ((yyvsp[0].value) << ShiftDstPort) & MaskDstPort, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch

	}
#line 2185 "grammar.c"
    break;

  case 33: /* term: dqual PORT IN PBLOCK  */
#line 581 "grammar.y"
                               {	
#ifdef NSEL
		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
					(yyval.param).self = NewBlock(OffsetPort, MaskSrcPort, ShiftSrcPort, CMP_EQ, FUNC_PBLOCK, NULL );
				break;
			case DESTINATION:
					(yyval.param).self = NewBlock(OffsetPort, MaskDstPort, ShiftDstPort, CMP_EQ, FUNC_PBLOCK, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, ShiftSrcPort, CMP_EQ, FUNC_PBLOCK, NULL ),
					NewBlock(OffsetPort, MaskDstPort, ShiftDstPort, CMP_EQ, FUNC_PBLOCK, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch

#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2216 "grammar.c"
    break;

  case 34: /* term: dqual PORT IN '[' ullist ']'  */
#line 608 "grammar.y"
                                       { 	
		struct ULongListNode *node;
		ULongtree_t *root = NULL;

		if ( (yyvsp[-5].param).direction == DIR_UNSPEC || (yyvsp[-5].param).direction == SOURCE_OR_DESTINATION || (yyvsp[-5].param).direction == SOURCE_AND_DESTINATION ) {
			// src and/or dst port
			// we need a second rbtree due to different shifts for src and dst ports
			root = malloc(sizeof(ULongtree_t));

			struct ULongListNode *n;
			if ( root == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			RB_INIT(root);

			RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
				if ( node->value > 65535 ) {
					yyerror("Port outside of range 0..65535");
					YYABORT;
				}
				if ((n = malloc(sizeof(struct ULongListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				n->value 	= (node->value << ShiftDstPort) & MaskDstPort;
				node->value = (node->value << ShiftSrcPort) & MaskSrcPort;
				RB_INSERT(ULongtree, root, n);
			}
		}

		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftSrcPort) & MaskSrcPort;
				}
				(yyval.param).self = NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftDstPort) & MaskDstPort;
				}
				(yyval.param).self = NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetPort, MaskSrcPort, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetPort, MaskDstPort, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 2284 "grammar.c"
    break;

  case 35: /* term: ICMP_TYPE NUMBER  */
#line 672 "grammar.y"
                           {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("ICMP type of range 0..255");
			YYABORT;
		}
		(yyval.param).self = Connect_AND(
			// imply ICMP-TYPE with a proto ICMP block
			Connect_OR (
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMP << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL), 
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMPV6 << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL)
			),
			NewBlock(OffsetICMP, MaskICMPtype, ((yyvsp[0].value) << ShiftICMPtype) & MaskICMPtype, CMP_EQ, FUNC_NONE, NULL )
		);

	}
#line 2304 "grammar.c"
    break;

  case 36: /* term: ICMP_CODE NUMBER  */
#line 688 "grammar.y"
                           {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("ICMP code of range 0..255");
			YYABORT;
		}
		(yyval.param).self = Connect_AND(
			// imply ICMP-CODE with a proto ICMP block
			Connect_OR (
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMP << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL), 
				NewBlock(OffsetProto, MaskProto, ((uint64_t)IPPROTO_ICMPV6 << ShiftProto)  & MaskProto, CMP_EQ, FUNC_NONE, NULL)
			),
			NewBlock(OffsetICMP, MaskICMPcode, ((yyvsp[0].value) << ShiftICMPcode) & MaskICMPcode, CMP_EQ, FUNC_NONE, NULL )
		);

	}
#line 2324 "grammar.c"
    break;

  case 37: /* term: ENGINE_TYPE comp NUMBER  */
#line 704 "grammar.y"
                                  {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Engine type of range 0..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetRouterID, MaskEngineType, ((yyvsp[0].value) << ShiftEngineType) & MaskEngineType, (yyvsp[-1].param).comp, FUNC_NONE, NULL);

	}
#line 2337 "grammar.c"
    break;

  case 38: /* term: ENGINE_ID comp NUMBER  */
#line 713 "grammar.y"
                                {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Engine ID of range 0..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetRouterID, MaskEngineID, ((yyvsp[0].value) << ShiftEngineID) & MaskEngineID, (yyvsp[-1].param).comp, FUNC_NONE, NULL);

	}
#line 2350 "grammar.c"
    break;

  case 39: /* term: ASA EVENT REASON  */
#line 722 "grammar.y"
                           {
#ifdef NSEL
		if ( strncasecmp((yyvsp[0].s),"ignore", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_IGNORE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"create", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_CREATE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"term", 4) == 0 || strncasecmp((yyvsp[0].s),"delete", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DELETE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp((yyvsp[0].s),"deny", 4) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp((yyvsp[0].s),"alert", 5) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_ALERT << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else if  (strncasecmp((yyvsp[0].s),"update", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_UPDATE << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL );
		} else {
			yyerror("Unknown asa event");
			YYABORT;
		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2378 "grammar.c"
    break;

  case 40: /* term: ASA EVENT comp NUMBER  */
#line 746 "grammar.y"
                                {
#ifdef NSEL
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Invalid xevent ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetConnID, MaskFWevent, ( (yyvsp[0].value) << ShiftFWevent) & MaskFWevent, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2395 "grammar.c"
    break;

  case 41: /* term: ASA EVENT DENIED inout  */
#line 759 "grammar.y"
                                 {
#ifdef NSEL
		uint64_t xevent = 0;
		if ( (yyvsp[0].param).inout == INGRESS ) {
			xevent = 1001;
		} else if ( (yyvsp[0].param).inout == EGRESS ) {
			xevent = 1002;
		} else {
				yyerror("Invalid inout token");
				YYABORT;
		}
		(yyval.param).self = Connect_AND(
			NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetConnID, MaskFWXevent, ( xevent << ShiftFWXevent) & MaskFWXevent, CMP_EQ, FUNC_NONE, NULL )
		);
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2420 "grammar.c"
    break;

  case 42: /* term: ASA EVENT DENIED STRING  */
#line 779 "grammar.y"
                                  {
#ifdef NSEL
		uint64_t xevent = 0;
		if( strncasecmp((yyvsp[0].s),"interface", 9) == 0) {
			xevent = 1003;
		} else if( strncasecmp((yyvsp[0].s),"nosyn", 5) == 0) {
			xevent = 1004;
		} else {
			xevent = (uint64_t)strtol((yyvsp[0].s), (char **)NULL, 10);
			if ( (xevent == 0 && errno == EINVAL) || xevent > 65535 ) {
				yyerror("Invalid xevent ID");
				YYABORT;
			}
		}
		(yyval.param).self = Connect_AND(
			NewBlock(OffsetConnID, MaskFWevent, ( NSEL_EVENT_DENIED << ShiftFWevent) & MaskFWevent, CMP_EQ, FUNC_NONE, NULL ),
			NewBlock(OffsetConnID, MaskFWXevent, ( xevent << ShiftFWXevent) & MaskFWXevent, CMP_EQ, FUNC_NONE, NULL )
		);
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2448 "grammar.c"
    break;

  case 43: /* term: ASA XEVENT comp NUMBER  */
#line 803 "grammar.y"
                                 {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Invalid xevent ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetConnID, MaskFWXevent, ( (yyvsp[0].value) << ShiftFWXevent) & MaskFWXevent, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2465 "grammar.c"
    break;

  case 44: /* term: dqual XNET STRING '/' NUMBER  */
#line 817 "grammar.y"
                                       { 
#ifdef NSEL
		int af, bytes, ret;
		uint64_t	mask[2];

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set


		if ( (yyvsp[0].value) > (bytes*8) ) {
			yyerror("Too many netbits for this IP address");
			YYABORT;
		}

		if ( af == PF_INET ) {
			mask[0] = 0xffffffffffffffffLL;
			mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
		} else {	// PF_INET6
			if ( (yyvsp[0].value) > 64 ) {
				mask[0] = 0xffffffffffffffffLL;
				mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
			} else {
				mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
				mask[1] = 0;
			}
		}
		// IP aadresses are stored in network representation 
		mask[0]	 = mask[0];
		mask[1]	 = mask[1];

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( (yyvsp[-4].param).direction ) {
			case SOURCE:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetXLATESRCv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATESRCv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetXLATEDSTv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetXLATEDSTv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2559 "grammar.c"
    break;

  case 45: /* term: dqual XPORT comp NUMBER  */
#line 907 "grammar.y"
                                  {	
#ifdef NSEL
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif

	}
#line 2601 "grammar.c"
    break;

  case 46: /* term: inout acl comp NUMBER  */
#line 945 "grammar.y"
                                {
#ifdef NSEL
		uint64_t offset, mask, shift;
		if ( (yyvsp[-3].param).inout == INGRESS ) {
			switch ((yyvsp[-2].param).acl) {
				case ACL:
					offset = OffsetIngressAclId;
					mask   = MaskIngressAclId;	
					shift  = ShiftIngressAclId;
					break;
				case ACE:
					offset = OffsetIngressAceId;
					mask   = MaskIngressAceId;	
					shift  = ShiftIngressAceId;
					break;
				case XACE:
					offset = OffsetIngressGrpId;
					mask   = MaskIngressGrpId;	
					shift  = ShiftIngressGrpId;
					break;
				default:
					yyerror("Invalid ACL specifier");
					YYABORT;
			}
		} else if ( (yyvsp[-3].param).inout == EGRESS && (yyval.param).acl == ACL ) {
			offset = OffsetEgressAclId;
			mask   = MaskEgressAclId;	
			shift  = ShiftEgressAclId;
		} else {
			yyerror("ingress/egress syntax error");
			YYABORT;
		}
		(yyval.param).self = NewBlock(offset, mask, ((yyvsp[0].value) << shift) & mask , (yyvsp[-1].param).comp, FUNC_NONE, NULL );

#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2645 "grammar.c"
    break;

  case 47: /* term: NAT EVENT REASON  */
#line 985 "grammar.y"
                           {
#ifdef NSEL
		if ( strncasecmp((yyvsp[0].s),"invalid", 7) == 0) {
			(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( NEL_EVENT_INVALID << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"add", 3) == 0 || strncasecmp((yyvsp[0].s),"create", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( NEL_EVENT_ADD << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else if( strncasecmp((yyvsp[0].s),"delete", 6) == 0) {
			(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( NEL_EVENT_DELETE << ShiftNATevent) & MasNATevent, CMP_EQ, FUNC_NONE, NULL );
		} else {
			yyerror("Unknown nat event");
			YYABORT;
		}
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2667 "grammar.c"
    break;

  case 48: /* term: NAT EVENT comp NUMBER  */
#line 1003 "grammar.y"
                                {
#ifdef NSEL
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Invalid event ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetNATevent, MasNATevent, ( (yyvsp[0].value) << ShiftNATevent) & MasNATevent, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2684 "grammar.c"
    break;

  case 49: /* term: INGRESS VRF comp NUMBER  */
#line 1016 "grammar.y"
                                  {
#ifdef NSEL
		if ( (yyvsp[0].value) > 0xFFFFFFFFLL ) {
			yyerror("Invalid ingress vrf ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetIVRFID, MaskIVRFID, ( (yyvsp[0].value) << ShiftIVRFID) & MaskIVRFID, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2701 "grammar.c"
    break;

  case 50: /* term: EGRESS VRF comp NUMBER  */
#line 1029 "grammar.y"
                                 {
#ifdef NSEL
		if ( (yyvsp[0].value) > 0xFFFFFFFFLL ) {
			yyerror("Invalid egress vrf ID");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetEVRFID, MaskEVRFID, ( (yyvsp[0].value) << ShiftEVRFID) & MaskEVRFID, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2718 "grammar.c"
    break;

  case 51: /* term: PBLOCK START comp NUMBER  */
#line 1042 "grammar.y"
                                   {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockStart, ( (yyvsp[0].value) << ShiftPortBlockStart) & MaskPortBlockStart, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2735 "grammar.c"
    break;

  case 52: /* term: PBLOCK END comp NUMBER  */
#line 1055 "grammar.y"
                                 {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockEnd, ( (yyvsp[0].value) << ShiftPortBlockEnd) & MaskPortBlockEnd, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2752 "grammar.c"
    break;

  case 53: /* term: PBLOCK STEP comp NUMBER  */
#line 1068 "grammar.y"
                                  {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockStep, ( (yyvsp[0].value) << ShiftPortBlockStep) & MaskPortBlockStep, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2769 "grammar.c"
    break;

  case 54: /* term: PBLOCK SIZE comp NUMBER  */
#line 1081 "grammar.y"
                                  {
#ifdef NSEL
		if ( (yyvsp[0].value) > 65536 ) {
			yyerror("Invalid port");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetPortBlock, MaskPortBlockSize, ( (yyvsp[0].value) << ShiftPortBlockSize) & MaskPortBlockSize, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
#else
		yyerror("NAT filters not available");
		YYABORT;
#endif
	}
#line 2786 "grammar.c"
    break;

  case 55: /* term: dqual NPORT comp NUMBER  */
#line 1094 "grammar.y"
                                  {	
#ifdef NSEL
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("Port outside of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATEPort, MaskXLATESRCPORT, ((yyvsp[0].value) << ShiftXLATESRCPORT) & MaskXLATESRCPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetXLATEPort, MaskXLATEDSTPORT, ((yyvsp[0].value) << ShiftXLATEDSTPORT) & MaskXLATEDSTPORT, (yyvsp[-1].param).comp, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch
#else
		yyerror("NEL/NAT filters not available");
		YYABORT;
#endif

	}
#line 2828 "grammar.c"
    break;

  case 56: /* term: dqual NIP STRING  */
#line 1132 "grammar.y"
                           { 	
#ifdef NSEL
		int af, bytes, ret;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Error parsing IP address.");
			YYABORT;
		}

		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		if ( ret == -2 ) {
			// could not resolv host => 'not any'
			(yyval.param).self = Invert(NewBlock(OffsetProto, 0, 0, CMP_EQ, FUNC_NONE, NULL )); 
		} else {
			uint64_t offsets[4] = {OffsetXLATESRCv6a, OffsetXLATESRCv6b, OffsetXLATEDSTv6a, OffsetXLATEDSTv6b };
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			switch ( (yyvsp[-2].param).direction ) {
				case SOURCE:
				case DESTINATION:
					(yyval.param).self = ChainHosts(offsets, IPstack, num_ip, (yyvsp[-2].param).direction);
					break;
				case DIR_UNSPEC:
				case SOURCE_OR_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_OR(src, dst);
					} break;
				case SOURCE_AND_DESTINATION: {
					uint32_t src = ChainHosts(offsets, IPstack, num_ip, SOURCE);
					uint32_t dst = ChainHosts(offsets, IPstack, num_ip, DESTINATION);
					(yyval.param).self = Connect_AND(src, dst);
					} break;
				default:
					yyerror("This token is not expected here!");
					YYABORT;
	
			} // End of switch

		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2883 "grammar.c"
    break;

  case 57: /* term: dqual NIP IN '[' iplist ']'  */
#line 1183 "grammar.y"
                                      { 	
#ifdef NSEL
		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetXLATESRCv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetXLATEDSTv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetXLATESRCv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetXLATEDSTv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetXLATESRCv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetXLATEDSTv6a, MaskIPv6, 0 , CMP_IPLIST, FUNC_NONE, (void *)(yyvsp[-1].list) )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}
#else
		yyerror("NSEL/ASA filters not available");
		YYABORT;
#endif
	}
#line 2919 "grammar.c"
    break;

  case 58: /* term: dqual AS comp NUMBER  */
#line 1215 "grammar.y"
                               {	
		if ( (yyvsp[0].value) > 0xfFFFFFFF ) {
			yyerror("AS number of range");
			YYABORT;
		}

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetAS, MaskSrcAS, ((yyvsp[0].value) << ShiftSrcAS) & MaskSrcAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetAS, MaskDstAS, ((yyvsp[0].value) << ShiftDstAS) & MaskDstAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetAS, MaskSrcAS, ((yyvsp[0].value) << ShiftSrcAS) & MaskSrcAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetAS, MaskDstAS, ((yyvsp[0].value) << ShiftDstAS) & MaskDstAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetAS, MaskSrcAS, ((yyvsp[0].value) << ShiftSrcAS) & MaskSrcAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL ),
					NewBlock(OffsetAS, MaskDstAS, ((yyvsp[0].value) << ShiftDstAS) & MaskDstAS, (yyvsp[-1].param).comp, FUNC_NONE, NULL)
				);
				break;
			case ADJ_PREV:
				(yyval.param).self = NewBlock(OffsetBGPadj, MaskBGPadjPrev, ((yyvsp[0].value) << ShiftBGPadjPrev) & MaskBGPadjPrev, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			case ADJ_NEXT:
				(yyval.param).self = NewBlock(OffsetBGPadj, MaskBGPadjNext, ((yyvsp[0].value) << ShiftBGPadjNext) & MaskBGPadjNext, (yyvsp[-1].param).comp, FUNC_NONE, NULL );
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 2962 "grammar.c"
    break;

  case 59: /* term: dqual AS IN '[' ullist ']'  */
#line 1254 "grammar.y"
                                     { 	
		struct ULongListNode *node;
		ULongtree_t *root = NULL;

		if ( (yyvsp[-5].param).direction == DIR_UNSPEC || (yyvsp[-5].param).direction == SOURCE_OR_DESTINATION || (yyvsp[-5].param).direction == SOURCE_AND_DESTINATION ) {
			// src and/or dst AS
			// we need a second rbtree due to different shifts for src and dst AS
			root = malloc(sizeof(ULongtree_t));

			struct ULongListNode *n;
			if ( root == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			RB_INIT(root);

			RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
				if ( node->value > 0xFFFFFFFFLL ) {
					yyerror("AS number of range");
					YYABORT;
				}
				if ((n = malloc(sizeof(struct ULongListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				n->value 	= (node->value << ShiftDstAS) & MaskDstAS;
				node->value = (node->value << ShiftSrcAS) & MaskSrcAS;
				RB_INSERT(ULongtree, root, n);
			}
		}

		switch ( (yyvsp[-5].param).direction ) {
			case SOURCE:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftSrcAS) & MaskSrcAS;
				}
				(yyval.param).self = NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DESTINATION:
				RB_FOREACH(node, ULongtree, (ULongtree_t *)(yyvsp[-1].list)) {
					node->value = (node->value << ShiftDstAS) & MaskDstAS;
				}
				(yyval.param).self = NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetAS, MaskSrcAS, 0, CMP_ULLIST, FUNC_NONE, (void *)(yyvsp[-1].list) ),
					NewBlock(OffsetAS, MaskDstAS, 0, CMP_ULLIST, FUNC_NONE, (void *)root )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		}

	}
#line 3030 "grammar.c"
    break;

  case 60: /* term: dqual MASK NUMBER  */
#line 1318 "grammar.y"
                            {	
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Mask outside of range 0..255");
			YYABORT;
		}

		switch ( (yyvsp[-2].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetMask, MaskSrcMask, ((yyvsp[0].value) << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetMask, MaskDstMask, ((yyvsp[0].value) << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetMask, MaskSrcMask, ((yyvsp[0].value) << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetMask, MaskDstMask, ((yyvsp[0].value) << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetMask, MaskSrcMask, ((yyvsp[0].value) << ShiftSrcMask) & MaskSrcMask, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetMask, MaskDstMask, ((yyvsp[0].value) << ShiftDstMask) & MaskDstMask, CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End switch

	}
#line 3067 "grammar.c"
    break;

  case 61: /* term: dqual NET STRING STRING  */
#line 1351 "grammar.y"
                                  { 
		int af, bytes, ret;
		uint64_t	mask[2];
		ret = parse_ip(&af, (yyvsp[-1].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af != PF_INET ) {
			yyerror("IP netmask syntax valid only for IPv4");
			YYABORT;
		}
		if ( bytes != 4 ) {
			yyerror("Need complete IP address");
			YYABORT;
		}

		ret = parse_ip(&af, (yyvsp[0].s), mask, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set

		if ( af != PF_INET || bytes != 4 ) {
			yyerror("Invalid netmask for IPv4 address");
			YYABORT;
		}

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( (yyvsp[-3].param).direction ) {
			case SOURCE:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);		
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				/* should never happen */
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3161 "grammar.c"
    break;

  case 62: /* term: dqual NET STRING '/' NUMBER  */
#line 1441 "grammar.y"
                                      { 
		int af, bytes, ret;
		uint64_t	mask[2];

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);
		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( ret == -1 ) {
			yyerror("IP address required - hostname not allowed here.");
			YYABORT;
		}
		// ret == -2 will never happen here, as STRICT_IP is set


		if ( (yyvsp[0].value) > (bytes*8) ) {
			yyerror("Too many netbits for this IP address");
			YYABORT;
		}

		if ( af == PF_INET ) {
			mask[0] = 0xffffffffffffffffLL;
			mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
		} else {	// PF_INET6
			if ( (yyvsp[0].value) > 64 ) {
				mask[0] = 0xffffffffffffffffLL;
				mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
			} else {
				mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
				mask[1] = 0;
			}
		}
		// IP aadresses are stored in network representation 
		mask[0]	 = mask[0];
		mask[1]	 = mask[1];

		IPstack[0] &= mask[0];
		IPstack[1] &= mask[1];

		switch ( (yyvsp[-4].param).direction ) {
			case SOURCE:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
				);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					Connect_AND(
						NewBlock(OffsetSrcIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetSrcIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					),
					Connect_AND(
						NewBlock(OffsetDstIPv6b, mask[1], IPstack[1] , CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetDstIPv6a, mask[0], IPstack[0] , CMP_EQ, FUNC_NONE, NULL )
					)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3250 "grammar.c"
    break;

  case 63: /* term: dqual IF NUMBER  */
#line 1526 "grammar.y"
                          {
		if ( (yyvsp[0].value) > 0xffffffffLL ) {
			yyerror("Input interface number must 0..2^32");
			YYABORT;
		}

		switch ( (yyvsp[-2].param).direction ) {
			case DIR_UNSPEC:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetInOut, MaskInput, ((yyvsp[0].value) << ShiftInput) & MaskInput, CMP_EQ, FUNC_NONE, NULL),
					NewBlock(OffsetInOut, MaskOutput, ((yyvsp[0].value) << ShiftOutput) & MaskOutput, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			case DIR_IN: 
				(yyval.param).self = NewBlock(OffsetInOut, MaskInput, ((yyvsp[0].value) << ShiftInput) & MaskInput, CMP_EQ, FUNC_NONE, NULL); 
				break;
			case DIR_OUT: 
				(yyval.param).self = NewBlock(OffsetInOut, MaskOutput, ((yyvsp[0].value) << ShiftOutput) & MaskOutput, CMP_EQ, FUNC_NONE, NULL); 
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3280 "grammar.c"
    break;

  case 64: /* term: dqual VLAN NUMBER  */
#line 1552 "grammar.y"
                            {	
		if ( (yyvsp[0].value) > 65535 ) {
			yyerror("VLAN number of range 0..65535");
			YYABORT;
		}

		switch ( (yyvsp[-2].param).direction ) {
			case SOURCE:
				(yyval.param).self = NewBlock(OffsetVlan, MaskSrcVlan, ((yyvsp[0].value) << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL );
				break;
			case DESTINATION:
				(yyval.param).self = NewBlock(OffsetVlan, MaskDstVlan, ((yyvsp[0].value) << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL);
				break;
			case DIR_UNSPEC:
			case SOURCE_OR_DESTINATION:
				(yyval.param).self = Connect_OR(
					NewBlock(OffsetVlan, MaskSrcVlan, ((yyvsp[0].value) << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetVlan, MaskDstVlan, ((yyvsp[0].value) << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			case SOURCE_AND_DESTINATION:
				(yyval.param).self = Connect_AND(
					NewBlock(OffsetVlan, MaskSrcVlan, ((yyvsp[0].value) << ShiftSrcVlan) & MaskSrcVlan, CMP_EQ, FUNC_NONE, NULL ),
					NewBlock(OffsetVlan, MaskDstVlan, ((yyvsp[0].value) << ShiftDstVlan) & MaskDstVlan, CMP_EQ, FUNC_NONE, NULL)
				);
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch

	}
#line 3317 "grammar.c"
    break;

  case 65: /* term: dqual MAC STRING  */
#line 1585 "grammar.y"
                           {
		uint64_t	mac = VerifyMac((yyvsp[0].s));
		if ( mac == 0 ) {
			yyerror("Invalid MAC address format");
			YYABORT;
		}
		switch ( (yyvsp[-2].param).direction ) {
			case DIR_UNSPEC: {
					uint32_t in, out;
					in  = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					out  = Connect_OR(
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					(yyval.param).self = Connect_OR(in, out);
					} break;
			case DIR_IN:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case DIR_OUT:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case SOURCE:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case DESTINATION:
					(yyval.param).self = Connect_OR(
						NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL ),
						NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL )
					);
					break;
			case IN_SRC: 
					(yyval.param).self = NewBlock(OffsetInSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case IN_DST: 
					(yyval.param).self = NewBlock(OffsetInDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case OUT_SRC: 
					(yyval.param).self = NewBlock(OffsetOutSrcMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
			case OUT_DST:
					(yyval.param).self = NewBlock(OffsetOutDstMAC, MaskMac, mac, CMP_EQ, FUNC_NONE, NULL );
					break;
				break;
			default:
				yyerror("This token is not expected here!");
				YYABORT;
		} // End of switch
	}
#line 3383 "grammar.c"
    break;

  case 66: /* term: MPLS STRING comp NUMBER  */
#line 1647 "grammar.y"
                                  {	
		if ( (yyvsp[0].value) > MPLSMAX ) {
			yyerror("MPLS value out of range");
			YYABORT;
		}

		// search for label1 - label10
		if ( strncasecmp((yyvsp[-2].s), "label", 5) == 0 ) {
			uint64_t mask;
			uint32_t offset, shift;
			char *s = &(yyvsp[-2].s)[5];
			if ( *s == '\0' ) {
				yyerror("Missing label number");
				YYABORT;
			}
			int i = (int)strtol(s, (char **)NULL, 10);

			switch (i) {
				case 1:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 2:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 3:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 4:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 5:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 6:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 7:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 8:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				case 9:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSlabelOdd;
					shift	= ShiftMPLSlabelOdd;
					break;
				case 10:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSlabelEven;
					shift	= ShiftMPLSlabelEven;
					break;
				default: 
					yyerror("MPLS label out of range 1..10");
					YYABORT;
			}
			(yyval.param).self = NewBlock(offset, mask, ((yyvsp[0].value) << shift) & mask, (yyvsp[-1].param).comp, FUNC_NONE, NULL );

		} else if ( strcasecmp((yyvsp[-2].s), "eos") == 0 ) {
			// match End of Stack label 
			(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value) << 4, (yyvsp[-1].param).comp, FUNC_MPLS_EOS, NULL );

		} else if ( strncasecmp((yyvsp[-2].s), "exp", 3) == 0 ) {
			uint64_t mask;
			uint32_t offset, shift;
			char *s = &(yyvsp[-2].s)[3];
			if ( *s == '\0' ) {
				yyerror("Missing label number");
				YYABORT;
			}
			int i = (int)strtol(s, (char **)NULL, 10);

			if ( (yyvsp[0].value) > 7 ) {
				yyerror("MPLS exp value out of range");
				YYABORT;
			}

			switch (i) {
				case 1:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 2:
					offset	= OffsetMPLS12;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 3:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 4:
					offset	= OffsetMPLS34;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 5:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 6:
					offset	= OffsetMPLS56;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 7:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 8:
					offset	= OffsetMPLS78;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				case 9:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSexpOdd;
					shift	= ShiftMPLSexpOdd;
					break;
				case 10:
					offset	= OffsetMPLS910;
					mask	= MaskMPLSexpEven;
					shift	= ShiftMPLSexpEven;
					break;
				default: 
					yyerror("MPLS label out of range 1..10");
					YYABORT;
			}
			(yyval.param).self = NewBlock(offset, mask, (yyvsp[0].value) << shift, (yyvsp[-1].param).comp, FUNC_NONE, NULL );

		} else {
			yyerror("Unknown MPLS option");
			YYABORT;
		}
	}
#line 3543 "grammar.c"
    break;

  case 67: /* term: MPLS ANY NUMBER  */
#line 1802 "grammar.y"
                          {	
		uint32_t *opt = malloc(sizeof(uint32_t));
		if ( (yyvsp[0].value) > MPLSMAX ) {
			yyerror("MPLS value out of range");
			YYABORT;
		}
		if ( opt == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		*opt = (yyvsp[0].value) << 4;
		(yyval.param).self = NewBlock(0, AnyMask, (yyvsp[0].value) << 4, CMP_EQ, FUNC_MPLS_ANY, opt );

	}
#line 3562 "grammar.c"
    break;

  case 68: /* term: FWDSTAT NUMBER  */
#line 1816 "grammar.y"
                         {
		if ( (yyvsp[0].value) > 255 ) {
			yyerror("Forwarding status of range 0..255");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetStatus, MaskStatus, ((yyvsp[0].value) << ShiftStatus) & MaskStatus, CMP_EQ, FUNC_NONE, NULL);
	}
#line 3574 "grammar.c"
    break;

  case 69: /* term: FWDSTAT STRING  */
#line 1824 "grammar.y"
                         {
		uint64_t id = Get_fwd_status_id((yyvsp[0].s));
		if (id == 256 ) {
			yyerror("Unknown forwarding status");
			YYABORT;
		}

		(yyval.param).self = NewBlock(OffsetStatus, MaskStatus, (id << ShiftStatus) & MaskStatus, CMP_EQ, FUNC_NONE, NULL);

	}
#line 3589 "grammar.c"
    break;

  case 70: /* term: DIR NUMBER  */
#line 1835 "grammar.y"
                     {
		if ( (yyvsp[0].value) > 2 ) {
			yyerror("Flow direction status of range 0, 1");
			YYABORT;
		}
		(yyval.param).self = NewBlock(OffsetDir, MaskDir, ((yyvsp[0].value) << ShiftDir) & MaskDir, CMP_EQ, FUNC_NONE, NULL);

	}
#line 3602 "grammar.c"
    break;

  case 71: /* term: DIR inout  */
#line 1844 "grammar.y"
                    {
		uint64_t dir = 0xFF;
		if ( (yyvsp[0].param).inout == INGRESS )
			dir = 0;
		else if ( (yyvsp[0].param).inout == EGRESS )
			dir = 1;
		else {
			yyerror("Flow direction status of range ingress, egress");
			YYABORT;
		}

		(yyval.param).self = NewBlock(OffsetDir, MaskDir, (dir << ShiftDir) & MaskDir, CMP_EQ, FUNC_NONE, NULL);

	}
#line 3621 "grammar.c"
    break;

  case 72: /* iplist: STRING  */
#line 1860 "grammar.y"
                { 
		int i, af, bytes, ret;
		struct IPListNode *node;

		IPlist_t *root = malloc(sizeof(IPlist_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		
		if ( ret != -2 ) {
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
				RB_INSERT(IPtree, root, node);
			}

		}
		(yyval.list) = (void *)root;

	}
#line 3668 "grammar.c"
    break;

  case 73: /* iplist: STRING '/' NUMBER  */
#line 1903 "grammar.y"
                                { 
		int af, bytes, ret;
		struct IPListNode *node;

		IPlist_t *root = malloc(sizeof(IPlist_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		// ret == -1 will never happen here, as ALLOW_LOOKUP is set
		
		if ( ret != -2 ) {
			if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
				yyerror("incomplete IP address");
				YYABORT;
			}

			if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}

			if ( af == PF_INET ) {
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
			} else {	// PF_INET6
				if ( (yyvsp[0].value) > 64 ) {
					node->mask[0] = 0xffffffffffffffffLL;
					node->mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
				} else {
					node->mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
					node->mask[1] = 0;
				}
			}

			node->ip[0] = IPstack[0] & node->mask[0];
			node->ip[1] = IPstack[1] & node->mask[1];

			RB_INSERT(IPtree, root, node);

		}
		(yyval.list) = (void *)root;

	}
#line 3726 "grammar.c"
    break;

  case 74: /* iplist: iplist STRING  */
#line 1957 "grammar.y"
                        { 
		int i, af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		// ret == - 2 means lookup failure
		if ( ret != -2 ) {
			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
	
				RB_INSERT(IPtree, (IPlist_t *)(yyval.list), node);
			}
		}
	}
#line 3762 "grammar.c"
    break;

  case 75: /* iplist: iplist ',' STRING  */
#line 1988 "grammar.y"
                            { 
		int i, af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, (yyvsp[0].s), IPstack, &bytes, ALLOW_LOOKUP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		// ret == - 2 means lookup failure
		if ( ret != -2 ) {
			for ( i=0; i<num_ip; i++ ) {
				if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
					yyerror("malloc() error");
					YYABORT;
				}
				node->ip[0] = IPstack[2*i];
				node->ip[1] = IPstack[2*i+1];
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL;
	
				RB_INSERT(IPtree, (IPlist_t *)(yyval.list), node);
			}
		}
	}
#line 3798 "grammar.c"
    break;

  case 76: /* iplist: iplist STRING '/' NUMBER  */
#line 2020 "grammar.y"
                                    { 
		int af, bytes, ret;
		struct IPListNode *node;

		ret = parse_ip(&af, (yyvsp[-2].s), IPstack, &bytes, STRICT_IP, &num_ip);

		if ( ret == 0 ) {
			yyerror("Invalid IP address");
			YYABORT;
		}
		if ( af && (( af == PF_INET && bytes != 4 ) || ( af == PF_INET6 && bytes != 16 ))) {
			yyerror("incomplete IP address");
			YYABORT;
		}

		// ret == - 2 means lookup failure
		if ( ret != -2 ) {
			if ((node = malloc(sizeof(struct IPListNode))) == NULL) {
				yyerror("malloc() error");
				YYABORT;
			}
			if ( af == PF_INET ) {
				node->mask[0] = 0xffffffffffffffffLL;
				node->mask[1] = 0xffffffffffffffffLL << ( 32 - (yyvsp[0].value) );
			} else {	// PF_INET6
				if ( (yyvsp[0].value) > 64 ) {
					node->mask[0] = 0xffffffffffffffffLL;
					node->mask[1] = 0xffffffffffffffffLL << ( 128 - (yyvsp[0].value) );
				} else {
					node->mask[0] = 0xffffffffffffffffLL << ( 64 - (yyvsp[0].value) );
					node->mask[1] = 0;
				}
			}

			node->ip[0] = IPstack[0] & node->mask[0];
			node->ip[1] = IPstack[1] & node->mask[1];

			RB_INSERT(IPtree, (IPlist_t *)(yyval.list), node);
		}
	}
#line 3843 "grammar.c"
    break;

  case 77: /* ullist: NUMBER  */
#line 2064 "grammar.y"
                { 
		struct ULongListNode *node;

		ULongtree_t *root = malloc(sizeof(ULongtree_t));

		if ( root == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		RB_INIT(root);

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = (yyvsp[0].value);

		RB_INSERT(ULongtree, root, node);
		(yyval.list) = (void *)root;
	}
#line 3868 "grammar.c"
    break;

  case 78: /* ullist: ullist NUMBER  */
#line 2085 "grammar.y"
                        { 
		struct ULongListNode *node;

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = (yyvsp[0].value);
		RB_INSERT(ULongtree, (ULongtree_t *)(yyval.list), node);
	}
#line 3883 "grammar.c"
    break;

  case 79: /* ullist: ullist ',' NUMBER  */
#line 2096 "grammar.y"
                            { 
		struct ULongListNode *node;

		if ((node = malloc(sizeof(struct ULongListNode))) == NULL) {
			yyerror("malloc() error");
			YYABORT;
		}
		node->value = (yyvsp[0].value);
		RB_INSERT(ULongtree, (ULongtree_t *)(yyval.list), node);
	}
#line 3898 "grammar.c"
    break;

  case 80: /* comp: %empty  */
#line 2110 "grammar.y"
                                { (yyval.param).comp = CMP_EQ; }
#line 3904 "grammar.c"
    break;

  case 81: /* comp: EQ  */
#line 2111 "grammar.y"
                                { (yyval.param).comp = CMP_EQ; }
#line 3910 "grammar.c"
    break;

  case 82: /* comp: LT  */
#line 2112 "grammar.y"
                                { (yyval.param).comp = CMP_LT; }
#line 3916 "grammar.c"
    break;

  case 83: /* comp: GT  */
#line 2113 "grammar.y"
                                { (yyval.param).comp = CMP_GT; }
#line 3922 "grammar.c"
    break;

  case 84: /* comp: LE  */
#line 2114 "grammar.y"
                                { (yyval.param).comp = CMP_LE; }
#line 3928 "grammar.c"
    break;

  case 85: /* comp: GE  */
#line 2115 "grammar.y"
                                { (yyval.param).comp = CMP_GE; }
#line 3934 "grammar.c"
    break;

  case 86: /* dqual: %empty  */
#line 2119 "grammar.y"
                                { (yyval.param).direction = DIR_UNSPEC;  			 }
#line 3940 "grammar.c"
    break;

  case 87: /* dqual: SRC  */
#line 2120 "grammar.y"
                                { (yyval.param).direction = SOURCE;				 }
#line 3946 "grammar.c"
    break;

  case 88: /* dqual: DST  */
#line 2121 "grammar.y"
                                { (yyval.param).direction = DESTINATION;			 }
#line 3952 "grammar.c"
    break;

  case 89: /* dqual: SRC OR DST  */
#line 2122 "grammar.y"
                        { (yyval.param).direction = SOURCE_OR_DESTINATION;  }
#line 3958 "grammar.c"
    break;

  case 90: /* dqual: DST OR SRC  */
#line 2123 "grammar.y"
                        { (yyval.param).direction = SOURCE_OR_DESTINATION;  }
#line 3964 "grammar.c"
    break;

  case 91: /* dqual: SRC AND DST  */
#line 2124 "grammar.y"
                        { (yyval.param).direction = SOURCE_AND_DESTINATION; }
#line 3970 "grammar.c"
    break;

  case 92: /* dqual: DST AND SRC  */
#line 2125 "grammar.y"
                        { (yyval.param).direction = SOURCE_AND_DESTINATION; }
#line 3976 "grammar.c"
    break;

  case 93: /* dqual: IN  */
#line 2126 "grammar.y"
                                { (yyval.param).direction = DIR_IN;				 }
#line 3982 "grammar.c"
    break;

  case 94: /* dqual: OUT  */
#line 2127 "grammar.y"
                                { (yyval.param).direction = DIR_OUT;				 }
#line 3988 "grammar.c"
    break;

  case 95: /* dqual: IN SRC  */
#line 2128 "grammar.y"
                                { (yyval.param).direction = IN_SRC;				 }
#line 3994 "grammar.c"
    break;

  case 96: /* dqual: IN DST  */
#line 2129 "grammar.y"
                                { (yyval.param).direction = IN_DST;				 }
#line 4000 "grammar.c"
    break;

  case 97: /* dqual: OUT SRC  */
#line 2130 "grammar.y"
                                { (yyval.param).direction = OUT_SRC;				 }
#line 4006 "grammar.c"
    break;

  case 98: /* dqual: OUT DST  */
#line 2131 "grammar.y"
                                { (yyval.param).direction = OUT_DST;				 }
#line 4012 "grammar.c"
    break;

  case 99: /* dqual: PREV  */
#line 2132 "grammar.y"
                                { (yyval.param).direction = ADJ_PREV;				 }
#line 4018 "grammar.c"
    break;

  case 100: /* dqual: NEXT  */
#line 2133 "grammar.y"
                                { (yyval.param).direction = ADJ_NEXT;				 }
#line 4024 "grammar.c"
    break;

  case 101: /* inout: INGRESS  */
#line 2136 "grammar.y"
                        { (yyval.param).inout	= INGRESS;	}
#line 4030 "grammar.c"
    break;

  case 102: /* inout: EGRESS  */
#line 2137 "grammar.y"
                                { (yyval.param).inout	= EGRESS;   }
#line 4036 "grammar.c"
    break;

  case 103: /* acl: ACL  */
#line 2140 "grammar.y"
                                { (yyval.param).acl = ACL; 	}
#line 4042 "grammar.c"
    break;

  case 104: /* acl: ACE  */
#line 2141 "grammar.y"
                                        { (yyval.param).acl = ACE;		}
#line 4048 "grammar.c"
    break;

  case 105: /* acl: XACE  */
#line 2142 "grammar.y"
                                { (yyval.param).acl = XACE;	}
#line 4054 "grammar.c"
    break;

  case 106: /* expr: term  */
#line 2145 "grammar.y"
                        { (yyval.value) = (yyvsp[0].param).self;        }
#line 4060 "grammar.c"
    break;

  case 107: /* expr: expr OR expr  */
#line 2146 "grammar.y"
                        { (yyval.value) = Connect_OR((yyvsp[-2].value), (yyvsp[0].value));  }
#line 4066 "grammar.c"
    break;

  case 108: /* expr: expr AND expr  */
#line 2147 "grammar.y"
                        { (yyval.value) = Connect_AND((yyvsp[-2].value), (yyvsp[0].value)); }
#line 4072 "grammar.c"
    break;

  case 109: /* expr: NOT expr  */
#line 2148 "grammar.y"
                                        { (yyval.value) = Invert((yyvsp[0].value));			}
#line 4078 "grammar.c"
    break;

  case 110: /* expr: '(' expr ')'  */
#line 2149 "grammar.y"
                        { (yyval.value) = (yyvsp[-1].value); }
#line 4084 "grammar.c"
    break;

  case 111: /* expr: '(' expr ')' '%' STRING  */
#line 2150 "grammar.y"
                                        { 
		(yyval.value) = (yyvsp[-3].value); 
		if ( strlen((yyvsp[0].s)) > 16 ) {
			yyerror("Error: Maximum 16 chars allowed for flowlabel");
			YYABORT;
		} else {
			AddLabel((yyvsp[-3].value), (yyvsp[0].s));
		}
	}
#line 4098 "grammar.c"
    break;

  case 112: /* expr: '%' STRING '(' expr ')'  */
#line 2159 "grammar.y"
                                  { 
		(yyval.value) = (yyvsp[-1].value); 
		if ( strlen((yyvsp[-3].s)) > 16 ) {
			yyerror("Error: Maximum 16 chars allowed for flowlabel");
			YYABORT;
		} else {
			AddLabel((yyvsp[-1].value), (yyvsp[-3].s));
		}
	}
#line 4112 "grammar.c"
    break;


#line 4116 "grammar.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2170 "grammar.y"


static void  yyerror(char *msg) {

	if ( FilterFilename )
		snprintf(yyerror_buff, 255 ,"File '%s' line %d: %s at '%s'", FilterFilename, lineno, msg, yytext);
	else 
		snprintf(yyerror_buff, 255, "Line %d: %s at '%s'", lineno, msg, yytext);

	yyerror_buff[255] = '\0';
	fprintf(stderr, "%s\n", yyerror_buff);

} /* End of yyerror */

static uint32_t ChainHosts(uint64_t *offsets, uint64_t *hostlist, int num_records, int type) {
uint32_t offset_a, offset_b, i, j, block;
	if ( type == SOURCE ) {
		offset_a = offsets[0];
		offset_b = offsets[1];
	} else {
		offset_a = offsets[2];
		offset_b = offsets[3];
	}

	i = 0;
	block = Connect_AND(
				NewBlock(offset_b, MaskIPv6, hostlist[i+1] , CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(offset_a, MaskIPv6, hostlist[i] , CMP_EQ, FUNC_NONE, NULL )
			);
	i += 2;
	for ( j=1; j<num_records; j++ ) {
		uint32_t b = Connect_AND(
				NewBlock(offset_b, MaskIPv6, hostlist[i+1] , CMP_EQ, FUNC_NONE, NULL ),
				NewBlock(offset_a, MaskIPv6, hostlist[i] , CMP_EQ, FUNC_NONE, NULL )
			);
		block = Connect_OR(block, b);
		i += 2;
	}

	return block;

} // End of ChainHosts

uint64_t VerifyMac(char *s) {
uint64_t mac;
size_t slen = strlen(s);
long l;
char *p, *q, *r;
int i;

	if ( slen > 17 )
		return 0; 

	for (i=0; i<slen; i++ ) {
		if ( !isxdigit(s[i]) && s[i] != ':' ) 
			return 0;
	}

	p = strdup(s);
	if ( !p ) {
		yyerror("malloc() error");
		return 0;
	}

	mac = 0;
	i = 0;	// number of MAC octets must be 6
	r = p;
	q = strchr(r, ':');
	while ( r && i < 6 ) {
		if ( q ) 
			*q = '\0';
		l = strtol(r, NULL, 16);
		if ( (i == 0 && errno == EINVAL) ) {
			free(p);
			return 0;
		}
		if ( l > 255 ) {
			free(p);
			return 0;
		}

		mac = ( mac << 8 ) | (l & 0xFF );
		i++;

		if ( q ) {
			r = ++q;
			q = strchr(r, ':');
		} else 
			r = NULL;
	}

	if ( i != 6 )
		return 0;

	return mac;

} // End of VerifyMac

static int InitSymbols(void) {
int i;

	// already initialised?
	if ( fwd_status )
		return 1;

	// fill fwd status cache table
	fwd_status = ( char **)calloc(256, sizeof(char *));
	if ( !fwd_status ) {
		fprintf(stderr, "malloc(): %s line %d: %s", __FILE__, __LINE__, strerror (errno));
		return 0;
	}
	i=0;
	while ( fwd_status_def_list[i].name ) {
		uint32_t j = fwd_status_def_list[i].id;
		fwd_status[j] = fwd_status_def_list[i].name;
		i++;
	}
	return 1;

} // End of InitSymbols

static uint32_t Get_fwd_status_id(char *status) {
int i;

	if ( !fwd_status && !InitSymbols() )
		yyerror("malloc() error");

	i = 0;
	while ( i < 256 ) {
		if ( fwd_status[i] && strcasecmp(fwd_status[i], status) == 0 ) 
			return i;
		i++;
	}
	return 256;

} // End of Get_fwd_status_id

